/*

        Copyright 2010, Yoshi Hiroshi

 */

#include <avr/io.h>

#define ADC_REF_VOLT                5000L
#define PWM_MAX_VAL                 255

#define STATUS_V_OUT                    0
#define STATUS_V_IN                     1
#define STATUS_I_IN                     2

#define ADC_CHANNEL_V_IN                3

int main()
{
// Port Setting
    PORTB = 0;
    DDRB = 0x02;
// TIMER/COUNTER Setting
    OCR0A = PWM_MAX_VAL;
    OCR0B = 0;
    TCCR0A = _BV(COM0B1) | _BV(COM0B0) | _BV(WGM01) | _BV(WGM00);
    TCCR0B = _BV(WGM02) | _BV(CS00);
// ADC Settting
    ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS0);
    ADMUX = _BV(ADLAR) | ADC_CHANNEL_V_IN;
    ADCSRA |= _BV(ADSC);
    
    while(1)
    {
        if(ADCSRA & _BV(ADIF)) {    // ADC complete?
            ADCSRA |= _BV(ADIF);        // clear flag
            OCR0B = ADCH;               // get adc  value (upper 8bit), set comp reg.
            ADCSRA |= _BV(ADSC);        // start next conversion
        }
    }
}
